[logo]: http://johnnythetank.github.io/apiNG/logo/320/aping-logo.png "apiNG"
![apiNG][logo]

[![Join the chat at https://gitter.im/JohnnyTheTank/apiNG](https://img.shields.io/badge/GITTER-join%20chat-green.svg)](https://gitter.im/JohnnyTheTank/apiNG?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
[![npm version](https://badge.fury.io/js/aping.svg)](https://badge.fury.io/js/aping)
[![Bower version](https://badge.fury.io/bo/apiNG.svg)](https://badge.fury.io/bo/apiNG)

**apiNG** is an AngularJS module that enables you to receive and display data from one or more sources. The data can be aggregated, limited and ordered. The complete setup is dead simple, just by adding data-attributes to your html.

There are two level of usage: _basic_ and _advanced_
* The _basic_ usage is focused on keeping it simple and easy, but with enough power for most use cases
* The _advanced_ usage turns apiNG into a plugin system for data-sources and designs, focused on re-usable modules

## Basic Demos
- Get data from **REST API**: [View & Edit on Plunker](http://plnkr.co/xmflhJ)
- Read data from **JSON Files**: [View & Edit on Plunker](http://plnkr.co/k3DPNc)

## Advanced Demos
- **Social Wall**
    - [Demopage](http://aping.js.org/#demo)
    - [View & Edit on Plunker](http://plnkr.co/dz3Dru)
- **Football-Data**
    - [View & Edit on Plunker](http://plnkr.co/a8Uj8V)
- **ionic + apiNG** (hybrid mobile apps)
    - [View & Edit on play.ionic.io](http://play.ionic.io/app/0137f0b5967d)
    - [View & Edit on Plunker](http://plnkr.co/edit/WesqTb?p=preview)

## References
- [sonymusic.de/videos](https://sonymusic.de/videos) (Youtube video playlist & player) based on apiNG
- [julia-lindholm.de](http://www.julia-lindholm.de/home/#news) (Facebook News) 
- [olliegabriel.de](http://www.olliegabriel.de/#news) (Facebook News)
- [chakuza.de](http://www.chakuza.de/news/) (Facebook News)
- [Article about apiNG on **t3n.de**](http://t3n.de/news/angularjs-modul-aping-686160/) (german)

More demos and references are listed at [aping.readme.io/docs/demos](https://aping.readme.io/docs/demos)

**Are you using apiNG for your next project?**
<br>[Let us know](https://github.com/JohnnyTheTank/apiNG/issues/new) if you use this module in your project and we'll add here!

## Documentation
**Full documentation comes up at [aping.readme.io](https://aping.readme.io)**

## Plugins
**apiNG plugin quicklist:** [Youtube](https://github.com/JohnnyTheTank/apiNG-plugin-youtube), [Facebook](https://github.com/JohnnyTheTank/apiNG-plugin-facebook), [Twitter](https://github.com/JohnnyTheTank/apiNG-plugin-codebird), [Vimeo](https://github.com/JohnnyTheTank/apiNG-plugin-vimeo), [Flickr](https://github.com/JohnnyTheTank/apiNG-plugin-flickr), [Dailymotion](https://github.com/JohnnyTheTank/apiNG-plugin-dailymotion), [Tumblr](https://github.com/JohnnyTheTank/apiNG-plugin-tumblr), [GitHub](https://github.com/JohnnyTheTank/apiNG-plugin-github), [RSS](https://github.com/JohnnyTheTank/apiNG-plugin-rss), [OpenWeatherMap](https://github.com/JohnnyTheTank/apiNG-plugin-openweathermap), [Wikipedia](https://github.com/JohnnyTheTank/apiNG-plugin-wikipedia), [BandsInTown](https://github.com/JohnnyTheTank/apiNG-plugin-bandsintown), [football-data](https://github.com/JohnnyTheTank/apiNG-plugin-footballdata)

All apiNG plugins are listed at [aping.readme.io/docs/all-plugins](https://aping.readme.io/docs/all-plugins)

## Designs
All apiNG designs are listed at [aping.readme.io/docs/all-designs](https://aping.readme.io/docs/all-designs)

# License
MIT